"use strict";

exports.__esModule = true;
exports["default"] = exports.Cinemagraph = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = require("prop-types");

require("./styles.css");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var Cinemagraph = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Cinemagraph, _Component);

  function Cinemagraph(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {};
    return _this;
  }

  var _proto = Cinemagraph.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.initBannerVideoSize('.video-container .poster img');
    this.initBannerVideoSize('.video-container .filter');
    this.initBannerVideoSize('.video-container video');
    window.addEventListener('resize', function () {
      _this2.scaleBannerVideoSize('.video-container .poster img');

      _this2.scaleBannerVideoSize('.video-container .filter');

      _this2.scaleBannerVideoSize('.video-container video');
    });
  };

  _proto.initBannerVideoSize = function initBannerVideoSize(elements) {
    document.querySelectorAll(elements).forEach(function (element) {
      element.setAttribute('data-height', parseInt(element.height, 10) + "px");
      element.setAttribute('data-width', parseInt(element.width, 10) + "px");
    });
    this.scaleBannerVideoSize(elements);
  };

  _proto.scaleBannerVideoSize = function scaleBannerVideoSize(elements) {
    var _this3 = this;

    var windowWidth = window.innerWidth;
    var windowHeight = window.innerHeight + 5;
    var videoWidth = 0;
    var videoHeight = 0;
    document.querySelectorAll(elements).forEach(function (element) {
      var videoAspectRatio = element.getAttribute('data-height') / element.getAttribute('data-width');
      _this3.innerWidth = windowWidth;

      if (windowWidth < 1000) {
        videoHeight = windowHeight;
        videoWidth = videoHeight / videoAspectRatio;
        document.querySelectorAll('body')[0].style.marginTop = 0;
        document.querySelectorAll('body')[0].style.marginLeft = -(videoWidth - windowWidth) / 2 + "px";
        document.querySelectorAll('body')[0].innerWidth = videoWidth + "px";
        document.querySelectorAll('body')[0].innerHeight = videoHeight + "px";
      }

      document.querySelectorAll('.homepage-hero-module .video-container video')[0].classList.add('fadeIn');
      document.querySelectorAll('.homepage-hero-module .video-container video')[0].classList.add('animated');
    });
  };

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].StrictMode, null, /*#__PURE__*/_react["default"].createElement("div", {
      className: "homepage-hero-module"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "video-container",
      style: {
        height: this.props.height + "vw",
        maxHeight: this.props.maxHeight + "vh"
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "poster hidden"
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: this.props.fallbackImage,
      alt: this.props.fallbackImageAlt
    }), ' '), ' ', /*#__PURE__*/_react["default"].createElement("div", {
      className: "filter"
    }), ' ', /*#__PURE__*/_react["default"].createElement("video", {
      autoPlay: true,
      playsInline: true,
      muted: true,
      loop: true,
      className: "\n                fillWidth\n                " + (this.props.isBlackAndWhite ? 'cinemagraph-black-and-white' : '') + "\n                " + (this.props.isSepia ? 'cinemagraph-sepia' : '') + "\n                " + (this.props.isBlurred ? 'cinemagraph-blur' : '') + "\n          "
    }, /*#__PURE__*/_react["default"].createElement("source", {
      src: this.props.mp4Source,
      type: "video/mp4"
    }), " Your browser does not support the video tag. I suggest you upgrade your browser.", ' ', /*#__PURE__*/_react["default"].createElement("source", {
      src: this.props.webmSource,
      type: "video/webm"
    }), "Your browser does not support the video tag. I suggest you upgrade your browser."), ' '), ' '));
  };

  return Cinemagraph;
}(_react.Component);

exports.Cinemagraph = Cinemagraph;
Cinemagraph.propTypes = process.env.NODE_ENV !== "production" ? {
  height: _propTypes.number.isRequired,
  maxHeight: _propTypes.number.isRequired,
  fallbackImage: _propTypes.any,
  fallbackImageAlt: _propTypes.string,
  mp4Source: _propTypes.any,
  webmSource: _propTypes.any,
  isBlackAndWhite: _propTypes.bool,
  isSepia: _propTypes.bool,
  isBlurred: _propTypes.bool
} : {};
var _default = Cinemagraph;
exports["default"] = _default;